<template>
    <div
        v-if="data && shop"
        class="email-preview-container"
    >
        <div class="email-preview-header">
            <span
                class="email-preview-header__subject"
                v-html="replaceText(data.subject)"
            />
            <span class="email-preview-header__shopname">admin@stilyoapps.com</span>
            <img
                src="../../../../assets/images/subject_fix_bg.jpg"
                class="email-preview-header__img"
            >
        </div>
        <div class="main-content">
            <div class="main-wrapper">
                <table width="100%">
                    <tbody>
                        <tr class="content-wrapper">
                            <td>
                                <table width="100%">
                                    <tbody>
                                        <tr class="email-header">
                                            <td
                                                v-if="data.logo && data.logo !== ''"
                                                :style="{background: '#fff'}"
                                                class="text-center"
                                                align="left"
                                                valign="middle"
                                            >
                                                <img
                                                    style="max-width: 100%"
                                                    :src="data.logo"
                                                >
                                            </td>
                                        </tr>
                                        <tr class="mail-title">
                                            <td align="center">
                                                <strong
                                                    :style="{color: data.colors.title}"
                                                    v-html="replaceText(data.title)"
                                                />
                                            </td>
                                        </tr>
                                        <tr class="mail-description">
                                            <td
                                                :style="{color: data.colors.body_text}"
                                                v-html="replaceText(data.paragraph_1)"
                                            />
                                        </tr>
                                        <tr class="cart-offer">
                                            <td>
                                                <p
                                                    class="text-left justify-content-start"
                                                    v-html="replaceText(data.cart_offer_texts.cart_offer_left)"
                                                />
                                                <div class="table-responsive-sm">
                                                    <table
                                                        width="100%"
                                                        border="0"
                                                        cellspacing="0"
                                                        cellpadding="0"
                                                        align="left"
                                                    >
                                                        <thead>
                                                            <tr>
                                                                <th style="width: 20%" />
                                                                <th
                                                                    style="width: 20%"
                                                                    v-html="replaceText(data.cart_offer_texts.cart_offer_product_description)"
                                                                />
                                                                <th
                                                                    style="width: 20%"
                                                                    v-html="replaceText(data.cart_offer_texts.cart_offer_product_price)"
                                                                />
                                                                <th
                                                                    style="width: 20%"
                                                                    v-html="replaceText(data.cart_offer_texts.cart_offer_product_qty)"
                                                                />
                                                                <th
                                                                    style="width: 20%"
                                                                    v-html="replaceText(data.cart_offer_texts.cart_offer_product_total)"
                                                                />
                                                            </tr>
                                                        </thead>
                                                        <tbody>
                                                            <tr class="cart-item">
                                                                <td>
                                                                    <div>
                                                                        <img
                                                                            src="../../../../assets/images/product-img-thumb.png"
                                                                            alt=""
                                                                            class="product-img"
                                                                        >
                                                                    </div>
                                                                </td>
                                                                <td
                                                                    align="center"
                                                                    class="cart-item-name"
                                                                >
                                                                    <a
                                                                        :style="{color: data.colors.link}"
                                                                        href="#"
                                                                    >Product title</a>
                                                                </td>
                                                                <td align="center">
                                                                    {{ data.product.price }}
                                                                </td>
                                                                <td align="center">
                                                                    1
                                                                </td>
                                                                <td align="center">
                                                                    {{ data.product.price }}
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td
                                                                    colspan="4"
                                                                    align="right"
                                                                    v-html="replaceText(data.cart_offer_texts.cart_offer_total)"
                                                                />
                                                                <td
                                                                    colspan="4"
                                                                    align="right"
                                                                >
                                                                    {{ data.product.price }}
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr class="action-button">
                                            <td align="right">
                                                <button
                                                    :style="{background: data.colors.button_color, color: data.colors.button_text}"
                                                    class="complete-button"
                                                    v-html="replaceText(data.button_text)"
                                                />
                                            </td>
                                        </tr>
                                        <tr class="bottom-text">
                                            <td align="left">
                                                <p  
                                                    :style="{color: data.colors.body_text}"
                                                    class="bottom-text-content"
                                                    v-html="replaceText(data.paragraph_2)"
                                                />
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                        <tr class="footer">
                            <td valign="middle">
                                <table>
                                    <tbody>
                                        <tr>
                                            <td>
                                                <p
                                                    style="white-space: pre-line;"
                                                    v-html="replaceText(data.footer)"
                                                >
                                                    <a
                                                        :style="{color: data.colors.link}"
                                                        href="#"
                                                    >Unsubscribe</a>
                                                </p>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</template>

<script>
import shop from '@/mixins/shop.service'

export default {
    name: "BrowseEmailExample",
    mixins: [shop],
    props: ['data'],
    data() {
        return {
            code: Math.random().toString(36).slice(2, 8).toUpperCase(),
            shop: null,
        }
    },
    created() {
        this.loadShop()
    },
    methods: {
        async loadShop() {
            this.shop = await this.getShop()
        },
        replaceText(text) {
            text = text.replace(/{domain}/g, `<a style="color: ${this.data.colors.link}" href="#">` + (this.shop.site_url ? this.shop.site_url: 'Shop URL') + '</a>');
            text = text.replace(/{firstName}/g, 'John');
            text = text.replace(/{lastName}/g, 'Doe');
            text = text.replace(/{siteName}/g, this.shop.custom_name || this.shop.site_name);
            text = text.replace(/{cartLink}/g, `<a style="color: ${this.data.colors.link}"  href="#">`);
            text = text.replace(/{\/cartLink}/g, '</a>');
            text = text.replace(/{unsubscribeLink}/g, `<a style="color: ${this.data.colors.link}" href="#">`);
            text = text.replace(/{\/unsubscribeLink}/g, '</a>');
            text = text.replace(/{discountValue}/g, this.data.automatic_discount_value );
            text = text.replace(/{discountCode}/g, this.data.automatic_discount_enabled == false ? this.data.code : this.code);
            text = text.replace(/{storeEmail}/g,  this.shop.custom_email || this.shop.email || 'Email');

            return text;
        }
    },
}
</script>

<style scoped lang="scss">

.mail-description {
    white-space: pre-line;
}
.footer > td table td p:first-child {
    margin-bottom: 0;
}
@import '../../../../css/email/card-example.scss'

</style>
